<?php
/*
Plugin Name: Buy Sell Ads
Plugin URI: http://omninoggin.com/projects/wordpress-plugins/buy-sell-ads-wordpress-plugin/
Description: This plugin helps you easily integrate Buy Sell Ads with anti-AdBlock measures.
Version: 0.5.3
Author: Thaya Kareeson
Author URI: http://omninoggin.com
*/

/*
Copyright 2009 Thaya Kareeson (email : thaya.kareeson@gmail.com)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class BuySellAds {

  var $bsa_url = 's3.buysellads.com';
  var $homepage = 'http://omninoggin.com/projects/wordpress-plugins/buy-sell-ads-wordpress-plugin/';
  var $name = 'buy_sell_ads'; 
  var $version = '0.5.3';

  function get_default_options() {
    return array(
      'after_zone' => '</div>',
      'after_widget' => '<div style="clear:both"></div>',
      'before_zone' => '<div style="float:left">',
      'before_widget' => '',
      'cache_interval' => 900,
      'enable_aab' => true,
      'nofollow' => false,
      'nonce_ts' => 0,
      'nonce_interval' => 1800,
      'widget_ids' => array(),
      'show_ad_here' => true,
      'show_link' => true,
      'style' => '
a {
  color:#888;
  display:block;
  float:left;
  font-family:verdana,sans-serif;
  font-size:11px;
  margin:5px;
  text-align:center;
  text-decoration:none;
  overflow:hidden;
}
img {
  border:0;
  clear:right;
}
a.adhere {
  background:#e7e7e7;
  border:1px solid #ccc;
  color:#666;
  font-size:12px;
  font-weight:bold;
  text-align:center;
}
a.adhere:hover {
  background:#ddd;
  border:1px solid #999;
  color:#333;
}',
      'version' => $this->version,
      'widget_title' => 'Sponsors'
    );
  }

  function activate() {
    $this->upgrade_options();
    $this->set_nonce_proxy();
  }

  function deactivate() {
    // nothing to clean up
  }

  function queue_jquery() {
    wp_enqueue_script('jquery');
  }

  function set_nonce_proxy() {
    $this->set_nonce('nonce_proxy');
    $this->clear_cache();
  }

  function set_nonce($seed) {
    $bsa_options = get_option($this->name);
    $bsa_options[$seed] = substr(md5(wp_create_nonce($name . $seed)), rand(0, 23), rand(4, 8));
    $bsa_options['nonce_ts'] = time();
    update_option($this->name, $bsa_options);
  }

  function need_upgrade() {
    $bsa_options = get_option($this->name);
    if ( array_key_exists('version', $bsa_options ) ) {
      $old_version_arr = split('\.', $bsa_options['version']);
      $new_version_arr = split('\.', $this->version);
      for($i = 0; $i < 3; $i++)
      {
        if ( (int)$new_version_arr[$i] > (int)$old_version_arr[$i] ) {
          return true;
        }
        elseif ( (int)$new_version_arr[$i] < (int)$old_version_arr[$i] ) {
          return false;
        }
      }
      return false;
    }
    return true;
  }

  function encrypt($string, $key) {
    $result = '';
    for($i=0; $i<strlen($string); $i++) {
      $char = substr($string, $i, 1);
      $keychar = substr($key, ($i % strlen($key))-1, 1);
      $char = chr(ord($char)+ord($keychar));
      $result.=$char;
    }

    return base64_encode($result);
  }

  function decrypt($string, $key) {
    $result = '';
    $string = base64_decode($string);
    
    for($i=0; $i<strlen($string); $i++) {
      $char = substr($string, $i, 1);
      $keychar = substr($key, ($i % strlen($key))-1, 1);
      $char = chr(ord($char)-ord($keychar));
      $result.=$char;
    }
    
    return $result;
  } 

  //function encrypt($string, $key) {
  //  return base64_encode($string);
  //}

  //function decrypt($string, $key) {
  //  return base64_decode($string);
  //} 

  function new_encrypted_url($matches) {
    $bsa_options = get_option($this->name);
    $ec = $this->encrypt($matches[1], $bsa_options['nonce_proxy']);
    return get_option('siteurl').'/'.$bsa_options['nonce_proxy'].$ec.'//'.$matches[2];
  }

  function replace_links($content) {
    $content = preg_replace_callback("/(?<!href=['\"])(http:\/\/[^\/]*?buysellads.*?)([\"'])/", array($this, 'new_encrypted_url'), $content);
    return $content;
  }

  function fetch_and_cache($req_uri, $cache_file) {
    $content = implode(file($req_uri));
    $content = $this->replace_links($content);

    // save cache file
    $fh = fopen($cache_file, 'w');
    if ( $fh ) {
      fwrite($fh, $content);
      fclose($fh);
    }
    else {
      // cannot open for write.  no error b/c something else is probably writing to the file.
    }

    return $content;
  }

  function cache_dir_writable() {
    $cache_dir = $this->get_plugin_dir().'/cache/';
    if ( is_writable($cache_dir) ) {
      return true;
    }
    else {
      return false;
    }
  }

  function refetch_cache_if_expired($req_uri, $cache_file) {
    $bsa_options = get_option($this->name);
    $cache_file_mtime = filemtime($cache_file);
    if ( (time() - $cache_file_mtime) > $bsa_options['cache_interval'] ) {
      $this->fetch_and_cache($req_uri, $cache_file);
    }
  }

  function clear_cache() {
    $cache_location = $this->get_plugin_dir().'/cache/';

    if(!$dh = @opendir($cache_location))
    {
      return;
    }
    while (false !== ($obj = readdir($dh)))
    {
      if($obj == '.' || $obj == '..')
      {
        continue;
      }
      @unlink($cache_location . '/' . $obj);
    }
    closedir($dh);
  
    if ( function_exists('prune_super_cache') ) {
      prune_super_cache( $this->get_content_dir().'/cache/', true );
    }
  }

  function fetch_content($req_uri) {
    $ec = $this->get_ec($req_uri);
    if ( strlen($ec) > 0 ) {
      $bsa_options = get_option($this->name);
      $dc = $this->decrypt($ec, $bsa_options['nonce_proxy']);
      $url = str_replace($bsa_options['nonce_proxy'], '', $req_uri);
      $url = trim($url, '/');
      $url = str_replace($ec, $dc, $url);
      $cache_file = $this->get_plugin_dir().'/cache/'.md5($url);
      $content = '';
      if ( file_exists($cache_file) ) {
        // check cache expiration
        $this->refetch_cache_if_expired($url, $cache_file);

        $fh = fopen($cache_file, 'r');
        if ( $fh && filesize($cache_file) > 0 ) {
          $content = fread($fh, filesize($cache_file));
          fclose($fh);
        }
        else {
          // cannot open cache file.  fetch from internet
          $content = $this->fetch_and_cache($url, $cache_file);
        }
      }
      else {
        // no cache file.  fetch from internet and save to local cache
        $content = $this->fetch_and_cache($url, $cache_file);
      }
    }
    return $content;
  }

  function get_ec($uri) {
    $bsa_options = get_option($this->name);
    $nonce_proxy = $bsa_options['nonce_proxy'];
    preg_match("/.*$nonce_proxy(.*?)\/\//", $uri, $matches);
    return $matches[1];
  }

  function proxy() {
    $bsa_options = get_option($this->name);
    if ( $bsa_options['enable_aab'] ) {
      $req_uri = $_SERVER['REQUEST_URI'];
      // intercept only BSA plugin specific request
      if ( strrpos($req_uri, $bsa_options['nonce_proxy']) ) {
        // fetch content from encrypted url
        echo $this->fetch_content($req_uri);
        exit();
      }

      // generate new nonce if it's time
      if ( (time() - $bsa_options['nonce_ts']) > $bsa_options['nonce_interval'] ) {
        $this->set_nonce_proxy();
      }
    }
  }

  function check_version() {
    if ( $this->need_upgrade() ) {
      // load text domain for translations
      load_plugin_textdomain($this->name);
      $this->upgrade_options();
      printf('<div class="updated fade"><p>%s</p></div>', __('Buy Sell Ads options has been upgraded.', $this->name));
    }
  }

  function update_options() {
    // new options
    $bsa_new_options = stripslashes_deep($_POST['bsa_options_update']);

    // current options
    $bsa_current_options = get_option($this->name);

    // convert "on" to true and "off" to false for checkbox fields
    // and set defaults for fields that are left blank
    if ( isset($bsa_new_options['enable_aab']) )
      $bsa_new_options['enable_aab'] = true;
    else
      $bsa_new_options['enable_aab'] = false;

    if ( isset($bsa_new_options['nofollow']) )
      $bsa_new_options['nofollow'] = true;
    else
      $bsa_new_options['nofollow'] = false;

    if ( isset($bsa_new_options['show_ad_here']) )
      $bsa_new_options['show_ad_here'] = true;
    else
      $bsa_new_options['show_ad_here'] = false;

    if ( isset($bsa_new_options['show_link']) && $bsa_new_options['show_link'] == "on")
      $bsa_new_options['show_link'] = true;
    else
      $bsa_new_options['show_link'] = false;

    // clear cache as JS code needs to be regenerated if anything above changed
    if (
      $bsa_new_options['enable_aab'] != $bsa_current_options['enable_aab']
      || $bsa_new_options['nofollow'] != $bsa_current_options['nofollow']
      || $bsa_new_options['show_ad_here'] != $bsa_current_options['show_ad_here']
      || $bsa_new_options['show_link'] != $bsa_current_options['show_link']
    ) {
      $this->clear_cache();
    }

    if ( isset($bsa_new_options['nonce_interval']) && !is_numeric($bsa_new_options['nonce_interval']) )
      $bsa_new_options['nonce_interval'] = $bsa_current_options['nonce_interval'];

    // Update options
    foreach($bsa_new_options as $key => $value) {
      $bsa_current_options[$key] = $value;
    }
    update_option($this->name, $bsa_current_options);
  }

  function upgrade_options() {
    $bsa_options = get_option($this->name);
    if ( !$bsa_options ) {
      add_option($this->name, $this->get_default_options());
    }
    else {
      $default_options = $this->get_default_options();
      foreach($default_options as $option_name => $option_value) {
        if(!isset($bsa_options[$option_name])) {
          $bsa_options[$option_name] = $option_value;
        }
      }
      $bsa_options['version'] = $this->version;
      update_option($this->name, $bsa_options);
    }
  }

  function reset_options() {
    $bsa_options = get_option($this->name);
    if ( !$bsa_options ) {
      add_option($this->name, $this->get_default_options());
    }
    else {
      // persists some options
      $default_options = $this->get_default_options();
      $default_options['widget_ids'] = $bsa_options['widget_ids'];
      update_option($this->name, $default_options);
    }
  }

  function get_content_dir() {
    // Pre-2.6 compatibility
    if ( !defined('WP_CONTENT_DIR') )
      define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
    return WP_CONTENT_DIR;
  }

  function get_plugin_dir() {
    // Pre-2.6 compatibility
    return $this->get_content_dir().'/plugins/'.plugin_basename(dirname(__FILE__));
  }

  function get_plugin_url() {
    // Pre-2.6 compatibility
    if ( !defined('WP_CONTENT_URL') )
      define( 'WP_CONTENT_URL', get_option('siteurl') . '/wp-content');
    return WP_CONTENT_URL.'/plugins/'.plugin_basename(dirname(__FILE__));
  }

  function get_current_page_url() {
    $isHTTPS = (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on");
    $port = (isset($_SERVER["SERVER_PORT"]) && ((!$isHTTPS && $_SERVER["SERVER_PORT"] != "80") || ($isHTTPS && $_SERVER["SERVER_PORT"] != "443")));
    $port = ($port) ? ':'.$_SERVER["SERVER_PORT"] : '';
    $url = ($isHTTPS ? 'https://' : 'http://').$_SERVER["SERVER_NAME"].$port.$_SERVER["REQUEST_URI"];
    return $url;
  }

  function style_to_array($quoted=true){
    $bsa_options = get_option($this->name);
    $style = $bsa_options['style'];
    // clean white spaces
    $style = join('', $this->array_trim(split(chr(10), str_replace(chr(13), '', $style))));
    // split into clauses
    $style = split('}', $style);
    array_pop($style); // last element is empty so get rid of it
    if ( $quoted ) {
      $callback = create_function('$e', 'return \'"\'.$e.\'}"\';');
    }
    else {
      $callback = create_function('$e', 'return $e.\'}\';');
    }
    return array_map($callback, $style);
  }

  function get_bsa_script($id, $show_ad_here=null, $nofollow=null){
    if ( is_numeric($id) ) {
      $bsa_options = get_option($this->name);
      if ( $bsa_options['enable_aab'] ) {
        $script_host = get_option('siteurl');
        $script_path = '/'.$bsa_options['nonce_proxy'].$this->encrypt('http://'.$this->bsa_url.'/'.$id.'/'.$id.'.js?v=', $bsa_options['nonce_proxy']).'//';
      }
      else {
        $script_host = 'http://'.$this->bsa_url;
        $script_path = '/'.$id.'/'.$id.'.js?v="+Date.parse(new Date())+"';
      }
      if ( !isset($show_ad_here) ) {
        $show_ad_here = ( $bsa_options['show_ad_here'] ) ? "true" : "false";
      }
      else {
        $show_ad_here = ( $show_ad_here ) ? "true" : "false";
      }
      if ( !isset($nofollow) ) {
        $nofollow = ( $bsa_options['nofollow'] ) ? "true" : "false";
      }
      else {
        $nofollow = ( $nofollow ) ? "true" : "false";
      }
      $script = sprintf('
        <script type="text/javascript">
          Vertical%s = false;
          ShowAdHereBanner%s = %s;
          RepeatAll%s = false;
          NoFollowAll%s = %s;
          BannerStyles%s = new Array(%s);
          
          document.write(unescape("%%3Cscript s"+"r"+"c"+"=\'%s"+"%s"+"\' type=\'text/javascript\'%%3E%%3C/script%%3E"));
        </script>
        ',
        $id,
        $id,
        $show_ad_here,
        $id,
        $id,
        $nofollow,
        $id,
        $style_code = join(',', $this->style_to_array(true)),
        $script_host,
        $script_path
      );
      return $script;
    }
    return '';
  }

  function print_bsa_script($id, $show_ad_here, $nofollow) {
    echo $this->get_bsa_script($id, $show_ad_here, $nofollow);
    echo '<div style="clear:both"></div>';
  }

  function widget_init(){
    register_sidebar_widget('Buy Sell Ads', array($this, 'widget'));    
    register_widget_control('Buy Sell Ads', array($this, 'widget_options'));    
  }

  function widget($args) {
    extract($args);
    echo $before_widget;
    $bsa_options = get_option($this->name);
    if ($bsa_options['widget_title']!='') {
      echo "\n".$before_title;
      echo $bsa_options['widget_title'];
      echo $after_title;
    }
    printf($bsa_options['before_widget']);
    $ids = $bsa_options['widget_ids'];
    foreach($ids as $id) {
      printf($bsa_options['before_zone']);
      echo $this->get_bsa_script($id);
      printf($bsa_options['after_zone']);
    }
    printf($bsa_options['after_widget']);
    if ( $bsa_options['show_link'] ) {
      printf('
        <p style="text-align:center"><a href="%s" style="font-size:10px" title="%s">%s</a></p>
        ',
        $this->homepage,
        __('Buy Sell Ads WordPress Plugin', $this->name),
        __('Powered by Buy Sell Ads Plugin', $this->name)
      );
    }
    echo $after_widget;
  }

  function array_trim($arr, $charlist=null){
    foreach($arr as $key => $value){
      if (is_array($value)) $result[$key] = array_trim($value, $charlist);
      else $result[$key] = trim($value, $charlist);
    }
    return $result;
  }

  function widget_options() {
    // load text domain for translations
    load_plugin_textdomain($this->name);

    // get options
    $bsa_options = get_option($this->name);

    // form posted?
    if ( $_POST['bsa_widget_options_submit'] ) {
      // Remember to sanitize and format use input appropriately.
      $bsa_new_widget_options = stripslashes_deep($_POST['bsa_widget_options']);
      // modify only widget options
      foreach( $bsa_new_widget_options as $option_name => $option_value){
        $bsa_options[$option_name] = $option_value;
      }
      // convert EOL delimited ids to array
      if ( strlen(trim($bsa_new_widget_options['widget_ids'])) > 0 ) {
        $bsa_options['widget_ids'] = $this->array_trim(split(chr(10), str_replace(chr(13), '', $bsa_new_widget_options['widget_ids'])));
      }
      else {
        $bsa_options['widget_ids'] = array();
      }
      update_option($this->name, $bsa_options);
    }

    // Get bsa_options for form fields to show
    $widget_title = htmlspecialchars($bsa_options['widget_title'], ENT_QUOTES);

    // The form fields
    printf('
      <p><label>%s<br/><input style="width:200px" name="bsa_widget_options[widget_title]" value="%s" /></label></p>
      <p><label>%s (<a href="%s">%s</a>)<br/><textarea name="bsa_widget_options[widget_ids]" style="width:100%%" rows="6">%s</textarea></label></p>
      <p><label>%s (<a href="%s">%s</a>)<br/><textarea name="bsa_widget_options[before_zone]" style="width:100%%" rows="3">%s</textarea></label></p>
      <p><label>%s (<a href="%s">%s</a>)<br/><textarea name="bsa_widget_options[after_zone]" style="width:100%%" rows="3">%s</textarea></label></p>
      <p><label>%s (<a href="%s">%s</a>)<br/><textarea name="bsa_widget_options[before_widget]" style="width:100%%" rows="3">%s</textarea></label></p>
      <p><label>%s (<a href="%s">%s</a>)<br/><textarea name="bsa_widget_options[after_widget]" style="width:100%%" rows="3">%s</textarea></label></p>
      ',
      __('Title:', $this->name),
      $widget_title,
      __('Buy Sell Ads Zone IDs:', $this->name),
      $this->homepage.'#widget-zone-ids',
      __('?', $this->name),
      attribute_escape(join(chr(10), $bsa_options['widget_ids'])),
      __('HTML before each ad zone:', $this->name),
      $this->homepage.'#before-zone',
      __('?', $this->name),
      attribute_escape($bsa_options['before_zone']),
      __('HTML after each ad zone:', $this->name),
      $this->homepage.'#after-zone',
      __('?', $this->name),
      attribute_escape($bsa_options['after_zone']),
      __('HTML before widget:', $this->name),
      $this->homepage.'#before-widget',
      __('?', $this->name),
      attribute_escape($bsa_options['before_widget']),
      __('HTML after widget:', $this->name),
      $this->homepage.'#after-widget',
      __('?', $this->name),
      attribute_escape($bsa_options['after_widget'])
    );
    echo '<input type="hidden" name="bsa_widget_options_submit" value="1" />';
    echo '<p style="text-align:right;">
       Additional options on <a href="' . get_option('siteurl') . '/wp-admin/options-general.php?page=buy-sell-ads">settings page</a>.
    </p>';
  }

  function admin_menu() {
    add_options_page('Buy Sell Ads', 'Buy Sell Ads', 'manage_options', 'buy-sell-ads', array($this, 'admin_page'));
  }

  function admin_page() {
    // load text domain for translations
    load_plugin_textdomain($this->name);

    if ( isset($_POST['bsa_options_update_submit']) ) {
      // if user wants to update options
      check_admin_referer($this->name);
      $this->update_options();
      printf('<div class="updated fade"><p>%s</p></div>', __('Buy Sell Ads options has been updated.', $this->name));
    }
    elseif ( isset($_POST['bsa_options_regenerate_nonce_submit']) ) {
      // if user wants to regenerate nonce
      check_admin_referer($this->name);
      $this->set_nonce_proxy();
      printf('<div class="updated fade"><p>%s</p></div>', __('Buy Sell Ads nonce has been re-generated.', $this->name));
    }
    elseif ( isset($_POST['bsa_options_clear_cache_submit']) ) {
      // if user wants to regenerate nonce
      check_admin_referer($this->name);
      $this->clear_cache();
      printf('<div class="updated fade"><p>%s</p></div>', __('Buy Sell Ads cache has been cleared.', $this->name));
    }
    elseif ( isset($_POST['bsa_options_upgrade_submit']) ) {
      // if user wants to upgrade options ( for new options on version upgrades )
      check_admin_referer($this->name);
      $this->upgrade_options();
      printf('<div class="updated fade"><p>%s</p></div>', __('Buy Sell Ads options has been upgraded.', $this->name));
    }
    elseif ( isset($_POST['bsa_options_reset_submit']) ) {
      // if user wants to reset all options
      check_admin_referer($this->name);
      $this->reset_options();
      $this->set_nonce_proxy();
      printf('<div class="updated fade"><p>%s</p></div>', __('Buy Sell Ads options has been reset.', $this->name));
    }

    if ( !$this->cache_dir_writable() ) {
      printf('<div class="error"><p>%s%s</p></div>', __('Cache directory is not writable.  Please grant your server write permissions to the directory:', $this->name), $this->get_plugin_dir().'/cache/');
    }

    printf('
      <div class="wrap">
        <h2>Buy Sell Ads Options</h2>
        <div>
          <a href="%s">%s</a>&nbsp;|&nbsp;
          <a href="%s">%s</a>
        </div>',
      preg_replace('/&bsa-page=[^&]*/', '', $_SERVER['REQUEST_URI']),
      __('General Configurations', $this->name),
      $this->homepage,
      __('Documentation', $this->name)
    );
    if ( isset($_GET['bsa-page']) ) {
      if ( $_GET['bsa-page'] || !$_GET['bsa-page'] ) {
        require_once('options-generic.php');
      }
    }
    else {
      require_once('options-generic.php');
    }
    printf('
      </div><!--wrap-->'
    );
  } // function admin_page()
} // class bsa

$buy_sell_ads = new BuySellAds();

if ( function_exists('add_action') ) {
  add_action('admin_notices', array($buy_sell_ads, 'check_version'));
  add_action('admin_menu', array($buy_sell_ads, 'admin_menu'));
  add_action('plugins_loaded', array($buy_sell_ads, 'proxy'));
  add_action('widgets_init', array($buy_sell_ads, 'widget_init'));
  add_action('wp_print_scripts', array($buy_sell_ads, 'queue_jquery'));
}

if ( function_exists('register_activation_hook') ) {
  register_activation_hook(__FILE__, array($buy_sell_ads, 'activate'));
}

if ( function_exists('register_deactivation_hook') ) {
  register_deactivation_hook(__FILE__, array($buy_sell_ads, 'deactivate'));
}

// function used for template insertion
function bsa_zone($id, $show_ad_here=null, $nofollow=null){
  global $buy_sell_ads;
  $buy_sell_ads->print_bsa_script($id, $show_ad_here, $nofollow);
}

?>
